# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "chaintools"
version = "0.0.3"
authors = ["alejandrogzi <alejandrxgzi@gmail.com>"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
default-run = "chaintools"
description = "work with .chain files in Rust"
homepage = "https://github.com/alejandrogzi/chaintools"
readme = "README.md"
keywords = [
    "chain",
    "lib",
    "genomic",
    "tool",
]
license = "MIT"
repository = "https://github.com/alejandrogzi/chaintools"

[features]
cli = [
    "dep:clap",
    "dep:log",
    "dep:simple_logger",
    "sequence",
    "dep:num_cpus",
]
default = [
    "mmap",
    "cli",
]
gzip = [
    "dep:flate2",
    "flate2/zlib-rs",
]
index = []
mmap = ["memmap2"]
parallel = ["rayon"]
sequence = ["dep:twobit"]

[lib]
name = "chaintools"
path = "src/lib.rs"

[[bin]]
name = "benchmark"
path = "bench/benchmark.rs"

[[bin]]
name = "chaintools"
path = "src/main.rs"
required-features = ["cli"]

[[test]]
name = "blocks"
path = "tests/blocks.rs"

[[test]]
name = "chains"
path = "tests/chains.rs"

[[test]]
name = "errors"
path = "tests/errors.rs"

[[test]]
name = "io"
path = "tests/io.rs"

[[test]]
name = "parsing"
path = "tests/parsing.rs"

[[test]]
name = "reader"
path = "tests/reader.rs"

[[test]]
name = "storage"
path = "tests/storage.rs"

[[test]]
name = "streaming"
path = "tests/streaming.rs"

[dependencies.clap]
version = "4"
features = ["derive"]
optional = true

[dependencies.flate2]
version = "1"
optional = true
default-features = false

[dependencies.log]
version = "0.4.29"
optional = true

[dependencies.memchr]
version = "2"

[dependencies.memmap2]
version = "0.9"
optional = true

[dependencies.num_cpus]
version = "1.17.0"
optional = true

[dependencies.rayon]
version = "1"
optional = true

[dependencies.simple_logger]
version = "5.2.0"
optional = true

[dependencies.twobit]
version = "0.2.2"
optional = true

[profile.release]
opt-level = 3
lto = true
codegen-units = 1
strip = true
